unit Blog;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.Handles, WeblogEcoSpace,
  CoreClassesUnit;

type
  TWebForm1 = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
                procedure btnSaveChanges_Click(sender: System.Object; e: System.EventArgs);
    procedure btnAddComment_Click(sender: System.Object; e: System.EventArgs);
  strict protected  
    rhRoot: Borland.Eco.Handles.ReferenceHandle;
                tbTitle: System.Web.UI.WebControls.TextBox;
                tbContents: System.Web.UI.WebControls.TextBox;
                HyperLink1: System.Web.UI.WebControls.HyperLink;
                lbPosted: System.Web.UI.WebControls.Label;
                lbAuthor: System.Web.UI.WebControls.Label;
                btnSaveChanges: System.Web.UI.WebControls.Button;
    dgComments: System.Web.UI.WebControls.DataGrid;
    btnAddComment: System.Web.UI.WebControls.Button;
    tbCommentAuthor: System.Web.UI.WebControls.TextBox;
    tbCommentComments: System.Web.UI.WebControls.TextBox;
    lbComments: System.Web.UI.WebControls.Label;
    ehComments: Borland.Eco.Handles.ExpressionHandle;
  {$ENDREGION}
  strict private
// ToDo replace Borland.Eco.Handles.EcoSpace with actual type of ecospace in project
// for fEcoSpace, get_EcoSpace and EcoSpace
    fEcoSpace: Borland.Eco.Handles.EcoSpace;
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
    procedure Page_Unload(sender: System.Object; e: System.EventArgs);
  strict protected
    procedure OnInit(e: EventArgs); override;
    function get_EcoSpace: Borland.Eco.Handles.EcoSpace;
    procedure DoneWithEcoSpace;
    property EcoSpace: Borland.Eco.Handles.EcoSpace read get_EcoSpace;
  public
    procedure DataBind; override;
    procedure UpdateComments; // BS
  strict protected
  {$REGION 'Utility Methods'}
    procedure UpdateDatabase;
    function IdForObject(Obj: IObject): string;
    function ObjectForId(Id: string): IObject;
  {$ENDREGION}
  {$REGION 'DataGrid Events'}
  procedure DataGrid_DeleteCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
  procedure DataGrid_EditCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
  procedure DataGrid_UpdateCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
  procedure DataGrid_CancelCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
  {$ENDREGION}
  end;

implementation

uses
  Borland.Eco.Services, EcoSpaceProvider;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWebForm1.InitializeComponent;
begin
  Self.rhRoot := Borland.Eco.Handles.ReferenceHandle.Create;
  Self.ehComments := Borland.Eco.Handles.ExpressionHandle.Create;
  Include(Self.btnSaveChanges.Click, Self.btnSaveChanges_Click);
  Include(Self.dgComments.DeleteCommand, Self.DataGrid_DeleteCommand);
  Include(Self.btnAddComment.Click, Self.btnAddComment_Click);
  // 
  // rhRoot
  // 
  Self.rhRoot.EcoSpaceType := TypeOf(WeblogEcoSpace.TWeblogEcoSpace);
  Self.rhRoot.StaticValueTypeName := 'Post';
  // 
  // ehComments
  // 
  Self.ehComments.AddExternalId := True;
  Self.ehComments.Expression := 'self.Comments';
  Self.ehComments.RootHandle := Self.rhRoot;
  Include(Self.Unload, Self.Page_Unload);
  Include(Self.Load, Self.Page_Load);
end;
{$ENDREGION}

procedure TWebForm1.Page_Load(sender: System.Object; e: System.EventArgs);
var
  Id: string;
begin
  EcoSpace.Active := True;
  Id := Request.Params['RootId'];
  if Assigned(Id) and (Id <> '') then
  begin
    rhRoot.SetElement(ObjectForId(Id));
    lbPosted.Text := (rhRoot.Element.AsObject as Post).Posted.ToString; // BS
    lbAuthor.Text := (rhRoot.Element.AsObject as Post).Author;          // BS
  end;
  if not IsPostBack then
    DataBind;
  // TODO: Put user code to initialize the page here
  btnSaveChanges.Visible := User.Identity.IsAuthenticated;
  if not IsPostBack then
    tbCommentAuthor.Text := User.Identity.Name;
  UpdateComments; // BS
  dgComments.Columns[3].Visible := User.Identity.IsAuthenticated
end;

procedure TWebForm1.Page_Unload(sender: System.Object; e: System.EventArgs);
begin
	DoneWithEcoSpace();
end;

procedure TWebForm1.DataBind;
begin
	ElementHandle.EnsureAllBindingLists;
  inherited DataBind;
end;

{$REGION 'Utility Methods'}
procedure TWebForm1.UpdateDatabase;
var
  PersistenceService: IPersistenceService;
  DirtyListService: IDirtyListService;
begin
  PersistenceService := EcoSpace.GetEcoService(typeof(IPersistenceService)) as IPersistenceService;
  DirtyListService := EcoSpace.GetEcoService(typeof(IDirtyListService)) as IDirtyListService;
  PersistenceService.UpdateDatabaseWithList(DirtyListService.AllDirtyObjects());
end;

function TWebForm1.IdForObject(Obj: IObject): string;
var
  IdService: IExternalIdService;
begin
  IdService := EcoSpace.GetEcoService(typeof(IExternalIdService)) as IExternalIdService;
  Result := IdService.IdForObject(Obj);
end;

function TWebForm1.ObjectForId(Id: string): IObject;
var
  IdService: IExternalIdService;
begin
  IdService := EcoSpace.GetEcoService(typeof(IExternalIdService)) as IExternalIdService;
  Result := IdService.ObjectForId(Id);
end;

{$ENDREGION}

{$REGION 'DataGrid Events'}

// The following code is useful if the form contains a System.Web.UI.Datagrid;
// It assumes that the elementhandle acting as a datasource has
// AddExternalId = true, and that datagrid.DataKeyField = "ExternalId"

procedure TWebForm1.DataGrid_DeleteCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
var
  SourceGrid: DataGrid;
  Id: string;
  ToDelete: IObject;
begin
  SourceGrid := source as DataGrid;
  Id := SourceGrid.DataKeys[e.Item.ItemIndex].ToString;
  ToDelete := ObjectForId(Id);
	if Assigned(ToDelete) then
    ToDelete.Delete;
  UpdateDatabase;
  DataBind;
  UpdateComments // BS
end;

procedure TWebForm1.DataGrid_EditCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
begin
  (source as DataGrid).EditItemIndex := e.Item.ItemIndex;
  DataBind;
end;

procedure TWebForm1.DataGrid_UpdateCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
var
  SourceGrid: DataGrid;
  Id: string;
  Row: TObject;
  Eh: ElementHandle;
  ColIndex: Integer;
  Col: BoundColumn;
begin
  SourceGrid := source as DataGrid;
  Id := SourceGrid.DataKeys[e.Item.ItemIndex].ToString;
  SourceGrid.DataBind(); // To set DataSource
  Eh := SourceGrid.DataSource as ElementHandle;
  Row := eh.RenderElement(ObjectForId(Id));
  for colIndex := 0 to SourceGrid.Columns.Count-1 do
  begin
    Col := BoundColumn(SourceGrid.Columns[colIndex]);
    if Assigned(Col) and (not Col.ReadOnly) then
      eh.SetRenderedElementProperty(row, Col.DataField, (e.Item.Cells[colIndex].Controls[0] as TextBox).Text, true);
  end;
	UpdateDatabase;
	SourceGrid.EditItemIndex := -1;
	DataBind;
end;

procedure TWebForm1.DataGrid_CancelCommand(source: TObject;e: System.Web.UI.WebControls.DataGridCommandEventArgs);
begin
  (source as DataGrid).EditItemIndex := -1;
  DataBind;
end;

procedure TWebForm1.btnAddComment_Click(sender: System.Object; e: System.EventArgs);
var
  C: Comment;
  P: Post;
begin
  P := rhRoot.Element.AsObject as Post;
  C := Comment.Create(EcoSpace);
  C.Author := tbCommentAuthor.Text;
  C.Comments := tbCommentComments.Text;
  C.Title := P.Title;
  C.Posted := DateTime.Now;
  C.Post := P; // add Comment to Post
  UpdateDatabase;
  DataBind;
  UpdateComments // BS
end;

procedure TWebForm1.btnSaveChanges_Click(sender: System.Object; e: System.EventArgs);
begin
  with (rhRoot.Element.AsObject as Post) do
  begin
    Title := tbTitle.Text;
    Contents := tbContents.Text;
  end;
  UpdateDatabase;
  DataBind
end;
{$ENDREGION}

procedure TWebForm1.OnInit(e: EventArgs);
begin
  //
  // Required for Designer support
  //
  InitializeComponent;
  inherited OnInit(e);
end;

function TWebForm1.get_EcoSpace: Borland.Eco.Handles.EcoSpace;
begin
  if not Assigned(fEcoSpace) then
  begin
    fecoSpace := TEcoSpaceProvider.GetEcoSpace;
		rhRoot.EcoSpace := fEcoSpace;
		// Set additional root handles here and in DoneWithEcoSpace
  end;
  Result := fEcoSpace;
end;

procedure TWebForm1.DoneWithEcoSpace;
begin
  if not Assigned(fEcoSpace) then
    Exit;
  rhRoot.EcoSpace := nil;
  rhRoot.SetElement(nil);
  // Clear all other references to ecoSpace or it's contents here.
	// Otherwise it is not safe to return it to a pool.

  TEcoSpaceProvider.ReturnEcoSpace(fEcoSpace);
  fEcoSpace := nil;
end;

procedure TWebForm1.UpdateComments;
begin
  if (rhRoot.Element.AsObject as Post).Comments.Count = 0 then
  begin
    lbComments.Text := 'No Comments, yet.';
    dgComments.Visible := False
  end
  else
  begin
    dgComments.Visible := True;
    if (rhRoot.Element.AsObject as Post).Comments.Count = 1 then
      lbComments.Text := (rhRoot.Element.AsObject as Post).Comments.Count.ToString + ' Comment'
    else
      lbComments.Text := (rhRoot.Element.AsObject as Post).Comments.Count.ToString + ' Comments'
  end
end;

end.

