unit CoreClassesUnit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes;

type
  Entry = class;
  Post = class;
  Comment = class;
  Category = class;
  [UmlElement('Package')]
  [EcoCodeGenVersion('1.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(Entry))]
  [UmlMetaAttribute('ownedElement', TypeOf(Post))]
  [UmlMetaAttribute('ownedElement', TypeOf(Comment))]
  [UmlMetaAttribute('ownedElement', TypeOf(Category))]
  CoreClasses = class
  public
  type
    [UmlElement('Association')]
    [UmlTaggedValue('derived', 'False')]
    Categorization = class
    end;
  type
    [UmlElement('Association')]
    [UmlTaggedValue('derived', 'False')]
    Commentary = class
    end;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(CoreClasses))]
  [UmlCollection(TypeOf(Entry))]
  [EcoAutoGenerated]
  IEntryList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Entry;
    procedure set_Item(index: Integer; Value: Entry);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Entry read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Entry): Integer;
    function Contains(value: Entry): Boolean;
    function IndexOf(value: Entry): Integer;
    procedure Insert(index: Integer; value: Entry);
    procedure Remove(value: Entry);
  end;
  [UmlElement]
  Entry = class abstract(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Author: string;
    procedure set__Author(Value: string);
    [EcoAutoGenerated]
    property _Author: string read get__Author write set__Author;
    function get__Title: string;
    procedure set__Title(Value: string);
    [EcoAutoGenerated]
    property _Title: string read get__Title write set__Title;
    function get__Posted: DateTime;
    procedure set__Posted(Value: DateTime);
    [EcoAutoGenerated]
    property _Posted: DateTime read get__Posted write set__Posted;
  protected
  const
    EntryFirstMember = 0;
  const
    EntryMemberCount = (Entry.EntryFirstMember + 3);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    EntryListAdapter = class(ObjectListAdapter, IEntryList)
    public
      constructor Create(source: IList);
      function Add(value: Entry): Integer;
      function Contains(value: Entry): Boolean;
      function IndexOf(value: Entry): Integer;
      procedure Insert(index: Integer; value: Entry);
      procedure Remove(value: Entry);
      function get_Item(index: Integer): Entry;
      procedure set_Item(index: Integer; value: Entry);
    end;
    function get_Author: string;
    procedure set_Author(Value: string);
    [UmlElement(Index=(Entry.EntryFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Author: string read get_Author write set_Author;
    function get_Title: string;
    procedure set_Title(Value: string);
    [UmlElement(Index=(Entry.EntryFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Title: string read get_Title write set_Title;
    function get_Posted: DateTime;
    procedure set_Posted(Value: DateTime);
    [UmlElement(Index=(Entry.EntryFirstMember + 2))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Posted: DateTime read get_Posted write set_Posted;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(Post))]
  [EcoAutoGenerated]
  IPostList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Post;
    procedure set_Item(index: Integer; Value: Post);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Post read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Post): Integer;
    function Contains(value: Post): Boolean;
    function IndexOf(value: Post): Integer;
    procedure Insert(index: Integer; value: Post);
    procedure Remove(value: Post);
  end;
  ICategoryList = interface;
  ICommentList = interface;
  [UmlElement]
  Post = class(Entry)
  strict protected
    function get__Contents: string;
    procedure set__Contents(Value: string);
    [EcoAutoGenerated]
    property _Contents: string read get__Contents write set__Contents;
    function get__Categories: IList;
    [EcoAutoGenerated]
    property _Categories: IList read get__Categories;
    function get__Comments: IList;
    [EcoAutoGenerated]
    property _Comments: IList read get__Comments;
  protected
  const
    PostFirstMember = Post.EntryMemberCount;
  const
    PostMemberCount = (Post.PostFirstMember + 3);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; override;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); override;
  type
    [EcoAutoGenerated]
    PostListAdapter = class(ObjectListAdapter, IPostList)
    public
      constructor Create(source: IList);
      function Add(value: Post): Integer;
      function Contains(value: Post): Boolean;
      function IndexOf(value: Post): Integer;
      procedure Insert(index: Integer; value: Post);
      procedure Remove(value: Post);
      function get_Item(index: Integer): Post;
      procedure set_Item(index: Integer; value: Post);
    end;
    function get_Contents: string;
    procedure set_Contents(Value: string);
    [UmlElement(Index=(Post.PostFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    [UmlTaggedValue('Eco.Length', '4096')]
    property Contents: string read get_Contents write set_Contents;
    [UmlElement]
    function WordCount(): integer;
    function get_Categories: ICategoryList;
    [UmlElement('AssociationEnd', Index=(Post.PostFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Categorization), Index=1)]
    [UmlMetaAttribute('multiplicity', '0..*')]
    property Categories: ICategoryList read get_Categories;
    function get_Comments: ICommentList;
    [UmlElement('AssociationEnd', Index=(Post.PostFirstMember + 2))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Commentary), Index=0)]
    [UmlMetaAttribute('multiplicity', '0..*')]
    property Comments: ICommentList read get_Comments;
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(Comment))]
  [EcoAutoGenerated]
  ICommentList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Comment;
    procedure set_Item(index: Integer; Value: Comment);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Comment read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Comment): Integer;
    function Contains(value: Comment): Boolean;
    function IndexOf(value: Comment): Integer;
    procedure Insert(index: Integer; value: Comment);
    procedure Remove(value: Comment);
  end;
  [UmlElement]
  Comment = class(Entry)
  strict protected
    function get__Comments: string;
    procedure set__Comments(Value: string);
    [EcoAutoGenerated]
    property _Comments: string read get__Comments write set__Comments;
    function get__Post: Post;
    procedure set__Post(Value: Post);
    [EcoAutoGenerated]
    property _Post: Post read get__Post write set__Post;
  protected
  const
    CommentFirstMember = Comment.EntryMemberCount;
  const
    CommentMemberCount = (Comment.CommentFirstMember + 2);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; override;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); override;
    function get_Comments: string;
    procedure set_Comments(Value: string);
    [UmlElement(Index=(Comment.CommentFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Comments: string read get_Comments write set_Comments;
  type
    [EcoAutoGenerated]
    CommentListAdapter = class(CoreClassesUnit.Entry.EntryListAdapter, ICommentList)
    public
      constructor Create(source: IList);
      function Add(value: Comment): Integer;
      function Contains(value: Comment): Boolean;
      function IndexOf(value: Comment): Integer;
      procedure Insert(index: Integer; value: Comment);
      procedure Remove(value: Comment);
      function get_Item(index: Integer): Comment;
      procedure set_Item(index: Integer; value: Comment);
    end;
    function get_Post: Post;
    procedure set_Post(Value: Post);
    [UmlElement('AssociationEnd', Index=(Comment.CommentFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Commentary), Index=1)]
    [UmlMetaAttribute('multiplicity', '1')]
    property Post: Post read get_Post write set_Post;
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(Category))]
  [EcoAutoGenerated]
  ICategoryList = interface
    function get_Count: Integer;
    function get_Item(index: Integer): Category;
    procedure set_Item(index: Integer; Value: Category);
    property Count: Integer read get_Count;
    property Item[index: Integer]: Category read get_Item write set_Item; default;
    procedure Clear;
    procedure RemoveAt(index: Integer);
    function Add(value: Category): Integer;
    function Contains(value: Category): Boolean;
    function IndexOf(value: Category): Integer;
    procedure Insert(index: Integer; value: Category);
    procedure Remove(value: Category);
  end;
  [UmlElement]
  Category = class(System.Object, ILoopBack)
  strict protected
    [EcoAutoGenerated]
    _content: IContent;
    function get__Name: string;
    procedure set__Name(Value: string);
    [EcoAutoGenerated]
    property _Name: string read get__Name write set__Name;
    function get__Posts: IList;
    [EcoAutoGenerated]
    property _Posts: IList read get__Posts;
  protected
  const
    CategoryFirstMember = 0;
  const
    CategoryMemberCount = (Category.CategoryFirstMember + 2);
  strict private
    {$REGION 'Autogenerated ECO code'}
  public
    [EcoAutoGenerated]
    function AsIObject: IObject;
    [EcoAutoGenerated]
    constructor Create(content: IContent); overload;
    [EcoAutoGenerated]
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    [EcoAutoGenerated]
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
  type
    [EcoAutoGenerated]
    CategoryListAdapter = class(ObjectListAdapter, ICategoryList)
    public
      constructor Create(source: IList);
      function Add(value: Category): Integer;
      function Contains(value: Category): Boolean;
      function IndexOf(value: Category): Integer;
      procedure Insert(index: Integer; value: Category);
      procedure Remove(value: Category);
      function get_Item(index: Integer): Category;
      procedure set_Item(index: Integer; value: Category);
    end;
    function get_Name: string;
    procedure set_Name(Value: string);
    [UmlElement(Index=(Category.CategoryFirstMember + 0))]
    [EcoAutoMaintained]
    [UmlTaggedValue('derived', 'False')]
    property Name: string read get_Name write set_Name;
    function get_Posts: IPostList;
    [UmlElement('AssociationEnd', Index=(Category.CategoryFirstMember + 1))]
    [EcoAutoMaintained]
    [UmlMetaAttribute('association', TypeOf(CoreClassesUnit.CoreClasses.Categorization), Index=0)]
    [UmlMetaAttribute('multiplicity', '0..*')]
    property Posts: IPostList read get_Posts;
  strict protected
    [EcoAutoGenerated]
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    [EcoAutoGenerated]
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
  strict private
    {$ENDREGION}
  public
    [EcoAutoMaintained]
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;

implementation



function Entry.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Entry.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Entry.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    EntryFirstMember + 0:
        result := System.Object(self.Author);
    EntryFirstMember + 1:
        result := System.Object(self.Title);
    EntryFirstMember + 2:
        result := System.Object(self.Posted);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Entry.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    EntryFirstMember + 0:
      self.Author := string(value);
    EntryFirstMember + 1:
      self.Title := string(value);
    EntryFirstMember + 2:
      self.Posted := DateTime(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Entry.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Entry.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Entry.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Entry.get__Posted: DateTime;
begin
  Result := (DateTime(Self._content.get_MemberByIndex((EntryFirstMember + 2))));
end;

procedure Entry.set__Posted(Value: DateTime);
begin
  Self._content.set_MemberByIndex((EntryFirstMember + 2), (System.Object(Value)));
end;

function Entry.get_Posted: DateTime;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Posted;
end;

procedure Entry.set_Posted(Value: DateTime);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Posted := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;

function Entry.get__Title: string;
begin
  Result := (string(Self._content.get_MemberByIndex((EntryFirstMember + 1))));
end;

procedure Entry.set__Title(Value: string);
begin
  Self._content.set_MemberByIndex((EntryFirstMember + 1), (System.Object(Value)));
end;

function Entry.get_Title: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Title;
end;

procedure Entry.set_Title(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Title := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;

function Entry.get__Author: string;
begin
  Result := (string(Self._content.get_MemberByIndex((EntryFirstMember + 0))));
end;

procedure Entry.set__Author(Value: string);
begin
  Self._content.set_MemberByIndex((EntryFirstMember + 0), (System.Object(Value)));
end;

function Entry.get_Author: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Author;
end;

procedure Entry.set_Author(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Author := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;



constructor Entry.EntryListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Entry.EntryListAdapter.Add(value: Entry): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Entry.EntryListAdapter.Contains(value: Entry): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Entry.EntryListAdapter.IndexOf(value: Entry): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Entry.EntryListAdapter.Insert(index: Integer; value: Entry);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Entry.EntryListAdapter.Remove(value: Entry);
begin
  Self.Adaptee.Remove(value);
end;

function Entry.EntryListAdapter.get_Item(index: Integer): Entry;
begin
  Result := Entry(Adaptee[index]);
end;

procedure Entry.EntryListAdapter.set_Item(index: Integer; value: Entry);
begin
  Adaptee[index] := value;
end;

constructor Post.Create(content: IContent);
begin
  inherited Create(content);
end;

function Post.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    PostFirstMember + 0:
        result := System.Object(self.Contents);
    PostFirstMember + 1:
        result := self.Categories;
    PostFirstMember + 2:
        result := self.Comments;
    else
      result := inherited get_MemberByIndex(index);
  end;
end;

procedure Post.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    PostFirstMember + 0:
      self.Contents := string(value);
    else
      inherited set_MemberByIndex(index, value);
  end;
end;
{$ENDREGION}

constructor Post.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Post.get__Comments: IList;
begin
  Result := (IList(Self._content.get_MemberByIndex((PostFirstMember + 2))));
end;

function Post.get_Comments: ICommentList;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := CoreClassesUnit.Comment.CommentListAdapter.Create(Self._Comments);
end;

function Post.get__Categories: IList;
begin
  Result := (IList(Self._content.get_MemberByIndex((PostFirstMember + 1))));
end;

function Post.get_Categories: ICategoryList;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := CoreClassesUnit.Category.CategoryListAdapter.Create(Self._Categories);
end;

function Post.WordCount(): integer;
var
  InSpace: Boolean;
  C: Char;
begin
  Result := 0;
  InSpace := True;
  for C in _Contents do
    if C <= #32 then InSpace := True
    else // not in space
      if InSpace then // used to be in space
      begin
        InSpace := False;
        Result := Result + 1
      end
end;

function Post.get__Contents: string;
begin
  Result := (string(Self._content.get_MemberByIndex((PostFirstMember + 0))));
end;

procedure Post.set__Contents(Value: string);
begin
  Self._content.set_MemberByIndex((PostFirstMember + 0), (System.Object(Value)));
end;

function Post.get_Contents: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Contents;
end;

procedure Post.set_Contents(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Contents := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;



constructor Post.PostListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Post.PostListAdapter.Add(value: Post): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Post.PostListAdapter.Contains(value: Post): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Post.PostListAdapter.IndexOf(value: Post): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Post.PostListAdapter.Insert(index: Integer; value: Post);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Post.PostListAdapter.Remove(value: Post);
begin
  Self.Adaptee.Remove(value);
end;

function Post.PostListAdapter.get_Item(index: Integer): Post;
begin
  Result := Post(Adaptee[index]);
end;

procedure Post.PostListAdapter.set_Item(index: Integer; value: Post);
begin
  Adaptee[index] := value;
end;

constructor Comment.Create(content: IContent);
begin
  inherited Create(content);
end;

function Comment.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    CommentFirstMember + 0:
        result := System.Object(self.Comments);
    CommentFirstMember + 1:
        result := self.Post;
    else
      result := inherited get_MemberByIndex(index);
  end;
end;

procedure Comment.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    CommentFirstMember + 0:
      self.Comments := string(value);
    CommentFirstMember + 1:
      self.Post := CoreClassesUnit.Post(value);
    else
      inherited set_MemberByIndex(index, value);
  end;
end;
{$ENDREGION}

constructor Comment.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Comment.get__Post: Post;
begin
  Result := (CoreClassesUnit.Post(Self._content.get_MemberByIndex((CommentFirstMember 
      + 1))));
end;

procedure Comment.set__Post(Value: Post);
begin
  Self._content.set_MemberByIndex((CommentFirstMember + 1), (System.Object(Value)));
end;

function Comment.get_Post: Post;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Post;
end;

procedure Comment.set_Post(Value: Post);
begin
  Self._Post := Value;
end;

constructor Comment.CommentListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Comment.CommentListAdapter.Add(value: Comment): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Comment.CommentListAdapter.Contains(value: Comment): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Comment.CommentListAdapter.IndexOf(value: Comment): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Comment.CommentListAdapter.Insert(index: Integer; value: Comment);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Comment.CommentListAdapter.Remove(value: Comment);
begin
  Self.Adaptee.Remove(value);
end;

function Comment.CommentListAdapter.get_Item(index: Integer): Comment;
begin
  Result := Comment(Adaptee[index]);
end;

procedure Comment.CommentListAdapter.set_Item(index: Integer; value: Comment);
begin
  Adaptee[index] := value;
end;



function Comment.get__Comments: string;
begin
  Result := (string(Self._content.get_MemberByIndex((CommentFirstMember + 0))));
end;

procedure Comment.set__Comments(Value: string);
begin
  Self._content.set_MemberByIndex((CommentFirstMember + 0), (System.Object(Value)));
end;

function Comment.get_Comments: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Comments;
end;

procedure Comment.set_Comments(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Comments := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;



function Category.AsIObject: IObject;
begin
  Result := Self._content.AsIObject;
end;

constructor Category.Create(content: IContent);
begin
  inherited Create;
  Self._content := content;
end;

function Category.get_MemberByIndex(index: Integer): System.Object;
begin
  case index of
    CategoryFirstMember + 0:
        result := System.Object(self.Name);
    CategoryFirstMember + 1:
        result := self.Posts;
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Category.set_MemberByIndex(index: Integer; value: System.Object);
begin
  case index of
    CategoryFirstMember + 0:
      self.Name := string(value);
    else
      raise System.IndexOutOfRangeException.Create();
  end;
end;

procedure Category.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self._content := factory.CreateContent(Self);
  end;
end;

procedure Category.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self._content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self._content, Self);
    Self._content := nil;
  end;
end;
{$ENDREGION}

constructor Category.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // If you add user code here, please remove the [EcoAutoMaintained] attribute
    // from the declaration in the interface section
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function Category.get__Posts: IList;
begin
  Result := (IList(Self._content.get_MemberByIndex((CategoryFirstMember + 1))));
end;

function Category.get_Posts: IPostList;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := CoreClassesUnit.Post.PostListAdapter.Create(Self._Posts);
end;

function Category.get__Name: string;
begin
  Result := (string(Self._content.get_MemberByIndex((CategoryFirstMember + 0))));
end;

procedure Category.set__Name(Value: string);
begin
  Self._content.set_MemberByIndex((CategoryFirstMember + 0), (System.Object(Value)));
end;

function Category.get_Name: string;
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Result := Self._Name;
end;

procedure Category.set_Name(Value: string);
begin
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
  Self._Name := Value;
  // If you add user code here, please remove the [EcoAutoMaintained] attribute
  // from the property declaration in the interface section
end;



constructor Category.CategoryListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function Category.CategoryListAdapter.Add(value: Category): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function Category.CategoryListAdapter.Contains(value: Category): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function Category.CategoryListAdapter.IndexOf(value: Category): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure Category.CategoryListAdapter.Insert(index: Integer; value: Category);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure Category.CategoryListAdapter.Remove(value: Category);
begin
  Self.Adaptee.Remove(value);
end;

function Category.CategoryListAdapter.get_Item(index: Integer): Category;
begin
  Result := Category(Adaptee[index]);
end;

procedure Category.CategoryListAdapter.set_Item(index: Integer; value: Category);
begin
  Adaptee[index] := value;
end;

{ CoreClasses }




{ CoreClasses }




{ CoreClasses }






























end.
